#!/bin/sh 
 # Emplacement et nom du script :
 # ~/.pekwm/ice2pek.sh
 # 
 # Dépendances : replaceit, pekwm, head, tail, wc, expr, script
 # dynamique date et heure pour pekwm, aemenu, less, un Puppy ou Toutou.
 #
 # But : composer un menu pekwm à partir d'un menu icewm 
 #   personalisé ou non, pour s'éviter de recommencer de zéro. 
 #
 # Suggestion :  Si vous n'avez pas personnalisé votre menu icewm, le 
 # mettre à jour en tapant "fixmenus" avant de lancer le présent script. 
 #
 # Ne pas oublier de lire les remarques supplémentaires à la fin
 # sur la concaténation des trois parties du menu pekwm.
 #
 # (c) musher0, Gatineau (Qc), Canada, 25 avril 2013. Gratuit pour les 
 # utilisateurs de Puppy | Toutou; néanmoins, tous droits, d'adaptation 
 # et autres, réservés.
 #### 

 ## variable initiale 
R="replaceit --input=GrandBout.txt" 

# On se positionne.
cd ~/.icewm # OU 
# cd ~/.lxp-icewm # selon la variante d'icewm que vous avez. 

 ## Pour ne pas altérer le menu d'icewm ou de lxp-icewm :
 # cp -f toolbar.moi GrandBout.txt # OU 
 # cp -f toolbar GrandBout.txt # OU 
cp -f menu GrandBout.txt 
 ## L'option par défaut fonctionne bien, mais vous avez d'autres choix.

 ## Effacer les lignes "wine" trop complexes, les lignes de remarques
 ## et les lignes de redémarrage. 
 $R --wholeline WINEPREFIX " " 
 $R --wholeline "#" " " 

 $R --wholeline Aide " "
# On la remettra à la fin.

# Enlève la section "Quitter"; reprise dans menu-fin.
 $R --wholeline Quitter " "
 $R --wholeline "l'ordi" " "
 $R --wholeline restart " " 
 
 # Traitement de tout le reste 
 $R "\" " "\" \"" 
 $R .xpm .xpm\" 
 $R .png .png\" 
 $R .jpg .jpg\" 
 $R .jpeg .jpg\" 
 # $R .ico .ico\" # En-cas.
 $R " \{" "\" \{" 
 $R "app " "app\" " # Pour ne pas toucher à "my-applications" 
 # $R folder folder\" # Non. Changer la "syntaxe" de cet icône associé aux 
 # sous-menus de icewm fausse l'interprétation des lignes marquées "menu". 
 $R "\" " "\";" 
 $R " \"" ";\"" 
 $R ";;" ; 
 $R "\" " "\";" 
 cut -d\; -f1,2,4 GrandBout.txt > GrandBout.nvo 

 ## La sous-séquence qui suit prévient le problème de l'ajout de 
 ## caractères en fin de ligne dans le menu pekwm. 

 echo > GrandBout.mod # crée un autre fichier de travail 
 while read line ; do 
    echo "$line -fin" >> GrandBout.mod 
 done < GrandBout.nvo 

 ## 2e variable R
 unset R 
 R="replaceit --input=GrandBout.mod" 
 $R "prog;" "Entry = " 
 $R "\";" "\" { Actions = \"Exec " 
 $R "-fin" "&\" }" 

 # On a marqué plus haut la fin de ligne EOL. Donc il faut 
 # remettre la valeur originale des lignes "menu", 
 $R "\" &\" }" "\" {" 
 $R "{ Actions = \"Exec { &\" }" { 

 # et des "accolades fermantes" de fin de sous-menu. 
 $R "} &\" }" } 
 $R " &\" }" " " "-Entry" 

 # Puis reconvertir les lignes "menu" ...
 $R "menu;" "Submenu = "

 # ... et les lignes de séparation au format pekwm. 
 $R separator "Separator {}" 
 $R "separator &\" }" "Separator {}" # au cas où 
 $R "separator}" "Separator {}" # (bis) :-) 

# Cas spéciaux pour certains sous-menus
 $R Fun Loisirs
 $R Network Réseau
 $R Desktop Bureau
 $R Personal Personnel
 $R Business Intendance
 $R System Ajustements
 $R Utility Autres
# Vous pouvez en changer.
 
# Enlever les lignes vides au début et à la fin
let x="`wc -l GrandBout.mod | cut -d' ' -f1`"
let y="`expr $x - 6 `"
tail -n $y GrandBout.mod > GrandBout.txt
let a="`wc -l GrandBout.txt | cut -d' ' -f1`"
let b="`expr $x - 21`"
head -n $b GrandBout.txt > GrandBout.mod

# Remettre la ligne d'aide 
echo "Entry = \"Aide\" { Actions = \"Exec defaulthtmlviewer file:///usr/share/doc/index.html &\" }" >> GrandBout.mod

#### Instructions supplémentaires ####
 # Une conversion de menu automatisée est rarement parfaite. Mais songez à
 # toute la frappe qu'il vous évite, même en l'état ! (:-) 
 #
 # Pour le compléter, je vous invite à vérifier et corriger à la main,
 # dans votre éditeur, le fichier "GrandBout.mod" avec la commande
 # defaulttexteditor ~/.icewm/GrandBout.mod
 # Profitez-en pour changer les titres des sous-menus si le coeur vous en dit.
 # 
 # Jetez un coup d'oeil aux accolades fermantes qui ne correspondraient pas 
 # à une accolade ouvrante. (Ça se voit facilement dans geany, qui les signale.) 
 # Solution la plus fréquente : enlevez l'accolade fermante orpheline.  
 # Une fois que vous êtes satisfait de votre révision, sauvegardez.
 
 # Il ne devrait pas y avoir d'erreurs dans les fichiers menu-début et menu-fin.
 # J'y ai mis beaucoup de soin.
 #
 # Votre révision terminée, en console, taper :
 # cd ~/.pekwm;cat menu-début >menu;cat ~/.icewm/GrandBout.mod >>menu;cat menu-fin >> menu
 #
 # Cette ligne créera un menu complet. Faites Ctrl-Alt-BackSpace pour aller à 
 # la console initiale, tapez "xwin pekwm" : au retour dans X, vous devriez 
 # avoir un menu pekwm fonctionnel.

 ####
 ## "Troisièmes" mains :
 # rm GrandBout.nvo # Nettoie un fichier de travail. 
 # rm GrandBout.mod # Attention ! Effacez seulement si 
 # vous avez créé un menu pekwm complet !

 # Si vous pensez être en panne, tapez :
 # cp -f GrandBout.cdr GrandBout.mod
 # Cela réactivera la copie de réserve pour une ré-édition du "GrandBout.mod". 
 # Ou encore réutilisez le présent script.
 